C**** THIS IS A MODIFIED VERSION OF A PROBLEM
C**** SUPPLIED BY FENG LING
C**** WE SHOW HERE HOW TO USE DONLP2 IN A PARAMETRIC APPLICATION:
C**** THE BOUNDS OF CONSTRAINING BOX ARE THIGHTENED UNTIL INFEASIBILITY
C**** OF THE PROBLEM IS OBTAINED
C**** THIS PROBLEM IS TO BE RUN IN COMBINATION WITH PARMAIN.F
C**** THERE A FACTOR BDFAC IS DEFINED WHICH ENTERS INTO THE DEFINITION
C**** OF THE BOUNDS
        SUBROUTINE SETUP
        INCLUDE 'O8COMM.INC'
C*** GIVING SHORT PROTOCOL ON STDOUT
C*** ANY CHANGE OF DONLP2'S STANDARD PARAMETER INITIALIZATION MUST BE
C*** DONE HERE
        RETURN
        END
        SUBROUTINE SETPAR
C    SPECIAL USER DATA ENTERING THE FUNCTION DEFINITON
        INCLUDE 'O8COMM.INC'
        INCLUDE 'USER1.INC'
        INTEGER J
        SAVE
        DO J=1,3
         ALAMDA(J)=0.01D0
         C(J)=-1.D1*DBLE(J)
         FDELTA(J)=0.1D0
         FDELTB(J)=0.05D0
        ENDDO
        XBAL=0.D0
        YBAL=0.D0
        XT(1)=-1.D0
        YT(1)=1.D0
        XT(2)=0.D0
        YT(2)=-1.D0
        XT(3)=1.D0
        YT(3)=1.D0
        F0(1)=10.D0
        F0(2)=20.D0
        F0(3)=5.D0
        FMAG=1.D-1
        DM0=2.D0
        WRENCH=1.D0
        FDELTR(0)=0.5D0
        RETURN
        END
        SUBROUTINE SETUP0
        INCLUDE 'O8COMM.INC'
        INCLUDE 'USER1.INC'
        INTEGER J,NUSER
        PARAMETER (NUSER=6)
        DOUBLE PRECISION XST0(NUSER)
        LOGICAL FIRST
        SAVE
        DATA FIRST/.TRUE./
C
C*** CASE IS INCREASED BY PARMAIN.F  ANY CASE HAS ITS OWN OUTPUT-FILE
        WRITE(NAME,FMT='(''FORCES'',I2.2)') CASE
C   X IS INITIAL GUESS AND ALSO HOLDS THE CURRENT SOLUTION
C   PROBLEM DIMENSION N=DIM(X), NH=DIM(H), NG=DIM(G)
        N=NUSER
        NH=3
        NG=9
        ANALYT=.TRUE.
        EPSDIF=0.D0
        PROU=10
        MEU=20
C   DEL0 AND TAU0: SEE BELOW
        DEL0=1.D0
        TAU0=1.D-1
        IF ( FIRST ) THEN
          COLD=.TRUE.
          CALL SETPAR
          DO J=1,N
            IF (J.GT.3) XST0(J)=ALAMDA(J-3)
            IF (J.LE.3) XST0(J)=500.D0
            X(J)=XST0(J)
          ENDDO
          DO J=0,3
            GUNIT(1,J)=-1
            GUNIT(2,J)=0
            GUNIT(3,J)=0
          ENDDO
          DO J=4,9
            GUNIT(1,J)=1
            GUNIT(2,J)=J-3
            GUNIT(3,J)=1
          ENDDO
          DO J=10,12
            GUNIT(1,J)=1
            GUNIT(2,J)=J-6
            GUNIT(3,J)=-1
          ENDDO
          FIRST=.FALSE.
        ELSE
          ITSTEP=0
          COLD=.FALSE.
        ENDIF
        RETURN
        END
C
C     OBJECTIVE FUNCTION (NEED VALUE OF FO, C)
        SUBROUTINE EF(X,FX)
        INCLUDE 'O8FUCO.INC'
        INCLUDE 'USER1.INC'
        DOUBLE PRECISION X(*),FX
        INTEGER J
        ICF=ICF+1
        FX=0.D0
        DO J=1,3
        FX=FX+(F0(J)+X(J))**2*(1+X(J+3)**2*C(J)**2)
        ENDDO
        RETURN
        END
C
C     GRADIENT OF OBJECTIVE FUNCTION (NEED TO KNOW F0,C)
        SUBROUTINE EGRADF(X,GRADF)
        INCLUDE 'O8FUCO.INC'
        INCLUDE 'USER1.INC'
        DOUBLE PRECISION X(*),GRADF(*)
        INTEGER J
C     USER DECLARATIONS, IF ANY ,FOLLOW
        ICGF=ICGF+1
        DO J=1,3
         GRADF(J)=2.D0*(1.D0+X(J+3)**2*C(J)**2)*(F0(J)+X(J))
         GRADF(J+3)=2.D0*C(J)**2*((F0(J)+X(J))**2)*X(J+3)
        ENDDO
        RETURN
        END
C
C  COMPUTE THE I-TH EQUALITY CONSTAINT, VALUE IS HXI (NEED TO KNOW FDELTA,
C  FDELTR,FMAG,C,FDELTB,F0,YBAL,XBAL,DMO,WRENCH,XT,YT)
        SUBROUTINE EH(I,X,HXI)
        INCLUDE 'O8FUCO.INC'
        INCLUDE 'USER1.INC'
        DOUBLE PRECISION X(*),HXI,ATI(3),PC,PS,PSS1,PSS2,PSS3,PSS4
        INTEGER I,J
        CRES(I)=CRES(I)+1
        HXI=0.D0
        GOTO (100,200,300),I
100     CONTINUE
        PC=FMAG*COS(FDELTR(0))
        DO J=1,3
        ATI(J)=COS(FDELTA(J))-X(J+3)*C(J)*SIN(FDELTA(J))
        ENDDO
        DO J=1,3
        HXI=HXI+ATI(J)*(X(J)+F0(J))
        ENDDO
        HXI=HXI+PC
        RETURN
200     CONTINUE
        PS=FMAG*SIN(FDELTR(0))
        DO J=1,3
        ATI(J)=SIN(FDELTA(J))+X(J+3)*C(J)*COS(FDELTA(J))
        ENDDO
        DO J=1,3
        HXI=HXI+ATI(J)*(X(J)+F0(J))
        ENDDO
        HXI=HXI+PS
        RETURN
300     CONTINUE
        DO J=1,3
        PSS1=SQRT(1+(C(J)**2)*(X(J+3)**2))
        PSS2=F0(J)+X(J)
        PSS3=SQRT((YBAL-YT(J))**2+(XBAL-XT(J))**2)
        PSS4=SIN(FDELTA(J)-FDELTB(J)+ATAN(X(J+3)*C(J)))
        HXI=HXI+PSS1*PSS2*PSS3*PSS4
        ENDDO
        HXI=HXI-DM0*WRENCH
        RETURN
        END
C
C  COMPUTE THE GRADIENT OF THE I-TH EQUALITY CONSTRAINT (NEED TO KNOW FDELTA,
C  FDELTR,FMAG,C,FDELTB,F0,YBAL,XBAL,XT,YT)
        SUBROUTINE EGRADH(I,X,GRADHI)
        INCLUDE 'O8FUCO.INC'
        INCLUDE 'USER1.INC'
        DOUBLE PRECISION X(*),GRADHI(*),PSS1,PSS2,PSS3,PSS4
        DOUBLE PRECISION GPSS1(6),GPSS2(6),GPSS4(6),ARG
        INTEGER I,J,K
        IF ( GUNIT(1,I) .NE. 1 ) CGRES(I)=CGRES(I)+1
C
        GOTO(100,200,300),I
100     CONTINUE
        DO J=1,3
        GRADHI(J)=COS(FDELTA(J))-X(J+3)*C(J)*SIN(FDELTA(J))
        GRADHI(J+3)=-C(J)*SIN(FDELTA(J))*(X(J)+F0(J))
        ENDDO
        RETURN
200     CONTINUE
        DO J=1,3
        GRADHI(J)=SIN(FDELTA(J))+X(J+3)*C(J)*COS(FDELTA(J))
        GRADHI(J+3)=C(J)*COS(FDELTA(J))*(X(J)+F0(J))
        ENDDO
        RETURN
300     CONTINUE
        DO K=1,6
          GRADHI(K)=0.D0
        ENDDO
        DO J=1,3
          PSS1=SQRT(1+(C(J)**2)*(X(J+3)**2))
          PSS2=F0(J)+X(J)
          PSS3=SQRT((YBAL-YT(J))**2+(XBAL-XT(J))**2)
          ARG=FDELTA(J)-FDELTB(J)+ATAN(X(J+3)*C(J))
          PSS4=SIN(ARG)
          DO K=1,6
            GPSS1(K)=0.D0
            GPSS2(K)=0.D0
            GPSS4(K)=0.D0
          ENDDO
          GPSS1(J+3)=X(J+3)*C(J)**2/PSS1
          GPSS2(J)=1.D0
          GPSS4(J+3)=COS(ARG)*C(J)/(1.D0+(X(J+3)*C(J))**2)
          DO K=1,6
           GRADHI(K)=GRADHI(K)+PSS3*(GPSS1(K)*PSS2*PSS4+
     F                               PSS1*GPSS2(K)*PSS4+
     F                               PSS1*PSS2*GPSS4(K))
          ENDDO
        ENDDO
        RETURN
        END
C
C COMPUTE THE I-TH INEQUALITY CONSTAINT, BOUNDS INCLUDED (NEED F0)
C
        SUBROUTINE EG(I,X,GXI)
        INCLUDE 'O8FUCO.INC'
        INCLUDE 'USER1.INC'
        DOUBLE PRECISION X(*),GXI
        INTEGER I,K
        IF ( GUNIT(1,I+NH) .EQ. -1 ) CRES(I+NH)=CRES(I+NH)+1
        K=(I-1)/3
        K=K+1
        GOTO (100,200,300), K
100     CONTINUE
        GXI=X(I)+F0(I)*BDFAC
        RETURN
200     CONTINUE
        GXI=X(I)+BDFAC
        RETURN
300     CONTINUE
        GXI=BDFAC-X(I-3)
        RETURN
        END
C
C COMPUTE THE GRADIENT OF THE I-TH INEQUALITY CONSTRAINT
        SUBROUTINE EGRADG(I,X,GRADGI)
        INCLUDE 'O8FUCO.INC'
        INCLUDE 'USER1.INC'
        DOUBLE PRECISION X(*) ,GRADGI(*)
        INTEGER I,K,J
        IF ( GUNIT(1,I+NH) .NE. 1 ) CGRES(I+NH)=CGRES(I+NH)+1
        DO J=1,6
        GRADGI(J)=0.D0
        ENDDO
        K=(I-1)/3
        K=K+1
        GOTO (100,100,200), K
100     CONTINUE
        GRADGI(I)=1.D0
        RETURN
200     CONTINUE
        GRADGI(I-3)=-1.D0
        RETURN
        END


