      SUBROUTINE SETUP
      RETURN
      END
C   HS105
      SUBROUTINE EF(X,FX)
      INCLUDE 'O8FUCO.INC'
      DOUBLE PRECISION X(NX),Y(235),FX,TERM,A,B,C,ARG,S
      DOUBLE PRECISION SQRT2PI
      INTEGER I
      SAVE SQRT2PI,Y
      DATA SQRT2PI/2.50662827463100050240D0/
      DATA Y/.475D0,.525D0,4*.55D0,4*.575D0,15*.6D0,15*.625D0,
     1       15*.65D0,13*.675D0,21*.7D0,12*.725D0,17*.75D0,4*.775D0,
     2       20*.8D0,8*.825D0,17*.85D0,8*.875D0,6*.9D0,6*.925D0,
     3       7*.95D0,4*.975D0,3*1.D0,3*1.025D0,8*1.05D0, 1.075D0,6*1.1D0
     4      ,5*1.15D0,1.175D0,7*1.2D0,1.225D0,2*1.25D0/
C   IN THE ORIGINAL SCALING THIS:
      IF ( ICF .EQ. 0 ) THEN
        DO I=1,235
          Y(I)=Y(I)*200.D0
        ENDDO
      ENDIF
      ICF=ICF+1
      S=0.D0
      DO      100      I=1,235
      TERM=-(Y(I)-X(3))**2/(2.D0*X(6)**2)
      IF ( TERM .LE. -200.D0 ) THEN
        A=0.D0
      ELSE
        A=EXP(TERM)*X(1)/X(6)
      ENDIF
      TERM=-(Y(I)-X(4))**2/(2.D0*X(7)**2)
      IF ( TERM .LE. -200.D0 ) THEN
        B=0.D0
      ELSE
        B=EXP(TERM)*X(2)/X(7)
      ENDIF
      TERM=-(Y(I)-X(5))**2/(2.D0*X(8)**2)
      IF(TERM .LE. -200.D0) THEN
        C=0.D0
      ELSE
        C=(1.D0-X(1)-X(2))/X(8)*EXP(TERM)
      ENDIF
      ARG=ABS(A+B+C)
C**** DUE TO THE BOUNDS IMPOSED, THIS SHOULD NEVER CHANGE ARG
      S=S-DLOG(ARG/SQRT2PI)
 100  CONTINUE
      FX=S
      RETURN
      END
      SUBROUTINE EGRADF(X,GRADF)
      INCLUDE 'O8FUCO.INC'
      INTEGER I
      DOUBLE PRECISION X(NX),GRADF(NX),Y(235),G(8),D
      DOUBLE PRECISION X1,X2,X3,X4,X5,X6,X7,X8,YI,T1,T2,T3,A,B,C
      SAVE Y
      DOUBLE PRECISION TERM
      DATA Y/.475D0,.525D0,4*.55D0,4*.575D0,15*.6D0,15*.625D0,
     1       15*.65D0,13*.675D0,21*.7D0,12*.725D0,17*.75D0,4*.775D0,
     2       20*.8D0,8*.825D0,17*.85D0,8*.875D0,6*.9D0,6*.925D0,
     3       7*.95D0,4*.975D0,3*1.D0,3*1.025D0,8*1.05D0, 1.075D0,6*1.1D0
     4      ,5*1.15D0,1.175D0,7*1.2D0,1.225D0,2*1.25D0/
C   IN THE ORIGINAL SCALING THIS:
      IF ( ICGF .EQ. 0 ) THEN
        DO I=1,235
          Y(I)=Y(I)*200.D0
        ENDDO
      ENDIF
      ICGF=ICGF+1
      DO        I=1,8
        G(I)=0.D0
      ENDDO
      X1=X(1)
      X2=X(2)
      X3=X(3)
      X4=X(4)
      X5=X(5)
      X6=X(6)
      X7=X(7)
      X8=X(8)
      DO      200      I=1,235
      YI=   Y(I)
      T1=(YI-X3)**2/(2.D0*X6**2)
      A=0.D0
      IF(T1 .LT. 200.D0)     A=EXP(-T1)
      T2=(YI-X4)**2/(2.D0*X7**2)
      B=0.D0
      IF(T2 .LT. 200.D0)     B=EXP(-T2)
      T3=(YI-X5)**2/(2.D0*X8**2)
      C=0.D0
      IF(T3 .LT. 200.D0)     C=EXP(-T3)
      D=1.D0/(X1*A/X6+X2*B/X7+(1.D0-X1-X2)/X8*C)
      G(1)=G(1)-D* (A/X6 - C/X8)
      G(2)=G(2)-D* (B/X7 - C/X8)
      G(3)=G(3)-D* (X1*A*(YI-X3)/X6**3)
      G(4)=G(4)-D* (X2*B*(YI-X4)/X7**3)
      G(5)=G(5)-D* (1.D0-X1-X2)*C*(YI-X5)/X8**3
      G(6)=G(6)-D* X1*A/X6**2*(-1.D0 +2.D0*T1)
      G(7)=G(7)-D* X2*B/X7**2*(-1.D0 +2.D0*T2)
      G(8)=G(8)-D* (1.D0-X1-X2)*C/X8**2*(-1.D0 +2.D0*T3)
  200 CONTINUE
      DO      300      I=1,8
      GRADF(I)=G(I)
  300 CONTINUE
      RETURN
      END
      SUBROUTINE EH(I,X,HXI)
      INCLUDE 'O8FUCO.INC'
      INTEGER I
      DOUBLE PRECISION X(NX),HXI
      CRES(I)=CRES(I)+1
      RETURN
      END
      SUBROUTINE EGRADH(I,X,GRADHI)
      INCLUDE 'O8FUCO.INC'
      INTEGER I
      DOUBLE PRECISION X(NX),GRADHI(NX)
      CGRES(I)=CGRES(I)+1
      RETURN
      END
      SUBROUTINE EG(I,X,GXI)
      INCLUDE 'O8FUCO.INC'
      INTEGER I
      DOUBLE PRECISION X(NX),UG(8),OG(8),GXI
      SAVE UG,OG
      DATA UG/2*1.D-3,100.D0,130.D0,170.D0,3*5.D0/
      DATA OG/2*.499D0,180.D0,210.D0,240.D0,3*25.D0/
      IF ( GUNIT(1,I+NH) .EQ. -1 )CRES(I+NH)=CRES(I+NH)+1
      IF(I .GT. 1)      GOTO 100
      GXI=1.D0-X(1)-X(2)
      RETURN
  100 CONTINUE
      IF(I .LE.  9)      GXI=X(I-1)-UG(I-1)
      IF(I .GT.  9)      GXI=OG(I-9)-X(I-9)
      RETURN
      END
      SUBROUTINE EGRADG(I,X,GRADGI)
      INCLUDE 'O8FUCO.INC'
      INTEGER I,J
      DOUBLE PRECISION X(NX) ,GRADGI(NX)
      IF ( GUNIT(1,I+NH) .EQ. 1 ) RETURN
      CGRES(I+NH)=CGRES(I+NH)+1
      GRADGI(1)=-1.D0
      GRADGI(2)=-1.D0
      DO J=3,8
        GRADGI(J)=0.D0
      ENDDO
      RETURN
      END
      BLOCK DATA
      INCLUDE 'O8BLOC.INC'
      INTEGER I,J
      DATA NAME/'HS105ORIG'/
      DATA (X(I),I=1,8)
     F    /.1D0,.2D0,100.D0,125.D0,175.D0,11.2D0,13.2D0,15.8D0/
      DATA N/ 8/ , NH/0/ , NG/17/
      DATA DEL0/0.001D0/ ,TAU0/1.D0/ ,TAU/.1D0/
      DATA ((GUNIT(I,J),I=1,3),J=0,1)/-1,0,0,-1,0,0/,
     F     (GUNIT(1,J),J=2,17)/16*1/,(GUNIT(2,J),J=2,17)/1,2,3,4,5,
     F     6,7,8,1,2,3,4,5,6,7,8/,(GUNIT(3,J),J=2,17)/8*1,8*-1/
      END
      SUBROUTINE SETUP0
      RETURN
      END
